var __assign = (undefined && undefined.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var UPDATE_STORE = '@@UPDATE_STORE@@';
function subscribeStore(atom, store) {
    var shouldNotUpateStore = false;
    var shouldNotUpateAtom = false;
    var unsubscribeStore = store.subscribe(function () {
        if (shouldNotUpateAtom) {
            shouldNotUpateAtom = false;
        }
        else {
            var storState_1 = store.getState();
            shouldNotUpateStore = true;
            atom.modify(function (atomState) {
                if (typeof atomState === 'object') {
                    return Object.keys(atomState).reduce(function (res, key) {
                        return Object.assign(res, storState_1[key] !== undefined && (_a = {}, _a[key] = storState_1[key], _a));
                        var _a;
                    }, {});
                }
                else {
                    return storState_1;
                }
            });
        }
    });
    var unsubscribeAtom = atom.subscribe(function (atomState) {
        if (shouldNotUpateStore) {
            shouldNotUpateStore = false;
        }
        else {
            shouldNotUpateAtom = true;
            store.dispatch({ type: UPDATE_STORE, state: atomState });
        }
    });
    return function () {
        unsubscribeStore();
        unsubscribeAtom.unsubscribe();
    };
}
function subscribeAtom(reducer) {
    if (typeof reducer === 'function') {
        return bindAction(reducer);
    }
    else {
        return Object.keys(reducer).reduce(function (res, key) {
            return (__assign({}, res, (_a = {}, _a[key] = bindAction(reducer[key], key), _a)));
            var _a;
        }, {});
    }
    function bindAction(reducer, key) {
        return function (state, action) {
            if (action.type === UPDATE_STORE) {
                var newState = key ? action.state[key] : action.state;
                return newState !== undefined ? newState : state;
            }
            return reducer(state, action);
        };
    }
}

export { subscribeStore, subscribeAtom };
//# sourceMappingURL=focal-redux.es5.js.map
